Bug 974724 - (ghc-haskell-lexer) Review Request: ghc-haskell-lexer - A fully compliant Haskell 98 lexer
Review Request: ghc-haskell-lexer - A fully compliant Haskell 98 lexer
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jens Petersen
Fedora Extras Quality Assurance
:
Depends On:
Blocks: ghc-pretty-show
  Show dependency treegraph
 
Reported: 2013-06-14 22:43 EDT by Ben Boeckel
Modified: 2013-09-13 22:35 EDT (History)
2 users (show)

See Also:
Fixed In Version: ghc-haskell-lexer-1.0-2.fc18
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-09-13 22:32:38 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
petersen: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Ben Boeckel 2013-06-14 22:43:33 EDT
Spec URL: http://benboeckel.net/packaging/ghc-haskell-lexer/ghc-haskell-lexer.spec
SRPM URL: http://benboeckel.net/packaging/ghc-haskell-lexer/ghc-haskell-lexer-1.0-1.fc20.src.rpm
Description:
A fully compliant Haskell 98 lexer

Fedora Account System Username: mathstuf

Scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=5505484
Comment 1 Mario Blättermann 2013-07-10 16:19:47 EDT
Scratch build failed:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5592819

From build.log:

+ sed -i -e 's!/builddir/build/BUILDROOT/ghc-haskell-lexer-1.0-1.fc20.x86_64!!g' ghc-haskell-lexer.files
+ for i in ghc-haskell-lexer.files ghc-haskell-lexer-devel.files
+ '[' -f ghc-haskell-lexer-devel.files ']'
+ sed -i -e 's!/builddir/build/BUILDROOT/ghc-haskell-lexer-1.0-1.fc20.x86_64!!g' ghc-haskell-lexer-devel.files
+ find /builddir/build/BUILDROOT/ghc-haskell-lexer-1.0-1.fc20.x86_64 -type f -exec sh -c 'file {} | grep -q '\''dynamically linked'\''' ';' -exec strip '{}' ';'
+ find /builddir/build/BUILDROOT/ghc-haskell-lexer-1.0-1.fc20.x86_64/usr/bin -type f -exec sh -c 'file {} | grep -q '\'' ELF '\''' ';' -exec execstack -c '{}' ';'
find: '/builddir/build/BUILDROOT/ghc-haskell-lexer-1.0-1.fc20.x86_64/usr/bin': No such file or directory
RPM build errors:
error: Bad exit status from /var/tmp/rpm-tmp.9gvoIx (%install)
    Bad exit status from /var/tmp/rpm-tmp.9gvoIx (%install)
Child return code was: 1
Comment 2 Jens Petersen 2013-07-21 06:46:33 EDT
Sorry that was my fault (I broke ghc-rpm-macros for one day the week before last).

It should build fine now.
Comment 3 Jens Petersen 2013-07-22 09:15:01 EDT
Only real problem I see is that the license file is MIT though
the cabal file claims it is BSD which it is not.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Static libraries in -static subpackage, if present.
  Note: Archive *.a files found in ghc-haskell-lexer-devel
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries

This is allowed for Fedora Haskell libraries.

- Large documentation must go in a -doc subpackage.
  Note: Documentation size is 1495040 bytes in 22 files.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation

Still smaller than size of the static libs - waived.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[-]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in ghc-
     haskell-lexer-devel

This is okay since API hash which is used in generated requires
is arch dependent anyway.

[x]: Package complies to the Packaging Guidelines
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.

License is MIT not BSD.

[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Arch-ed rpms have a total of 1525760 bytes in /usr/share 10240 ghc-
     haskell-lexer-1.0-1.fc20.x86_64.rpm 1515520 ghc-haskell-lexer-
     devel-1.0-1.fc20.x86_64.rpm

I feel this can be waived:

$ du -s ghc-haskell-lexer-devel-1.0-1.fc20.x86_64.rpm/usr/*
8112	lib64
1500	share

[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ghc-haskell-lexer-1.0-1.fc20.x86_64.rpm
          ghc-haskell-lexer-devel-1.0-1.fc20.x86_64.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.


Rpmlint (installed packages)
----------------------------
# rpmlint ghc-haskell-lexer ghc-haskell-lexer-devel
2 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'


Requires
--------
ghc-haskell-lexer (rpmlib, GLIBC filtered):
    ghc(base-4.6.0.1-8aa5d403c45ea59dcd2c39f123e27d57)
    libHSbase-4.6.0.1-ghc7.6.3.so()(64bit)
    libHSghc-prim-0.3.0.0-ghc7.6.3.so()(64bit)
    libHSinteger-gmp-0.5.0.0-ghc7.6.3.so()(64bit)
    libc.so.6()(64bit)
    libgmp.so.10()(64bit)
    rtld(GNU_HASH)

ghc-haskell-lexer-devel (rpmlib, GLIBC filtered):
    /bin/sh
    ghc(haskell-lexer-1.0-4cd87c449a1c5d8d5a2f881ebc601d24)
    ghc-compiler
    ghc-devel(base-4.6.0.1-8aa5d403c45ea59dcd2c39f123e27d57)
    ghc-haskell-lexer


Provides
--------
ghc-haskell-lexer:
    ghc(haskell-lexer-1.0-4cd87c449a1c5d8d5a2f881ebc601d24)
    ghc-haskell-lexer
    ghc-haskell-lexer(x86-64)
    libHShaskell-lexer-1.0-ghc7.6.3.so()(64bit)

ghc-haskell-lexer-devel:
    ghc-devel(haskell-lexer-1.0-4cd87c449a1c5d8d5a2f881ebc601d24)
    ghc-haskell-lexer-devel
    ghc-haskell-lexer-devel(x86-64)


Unversioned so-files
--------------------
ghc-haskell-lexer: /usr/lib64/ghc-7.6.3/haskell-lexer-1.0/libHShaskell-lexer-1.0-ghc7.6.3.so

Source checksums
----------------
http://hackage.haskell.org/packages/archive/haskell-lexer/1.0/haskell-lexer-1.0.tar.gz :
  CHECKSUM(SHA256) this package     : 86d0c4071295c8613eb965768cb61a0c8422fc0c429a49c7a93e93a72b185b86
  CHECKSUM(SHA256) upstream package : 86d0c4071295c8613eb965768cb61a0c8422fc0c429a49c7a93e93a72b185b86


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -b 974724


I am happy to approve if you update License to MIT.
But this discrepancy should be reported to the author.
Comment 5 Jens Petersen 2013-08-26 03:51:16 EDT
Ben, will you update the package or do you want to fix it when importing?
Comment 7 Jens Petersen 2013-08-26 21:37:48 EDT
Thanks - looks good now.

Package APPROVED
Comment 8 Ben Boeckel 2013-08-26 22:03:33 EDT
New Package SCM Request
=======================
Package Name: ghc-haskell-lexer
Short Description: A fully compliant Haskell 98 lexer
Owners: mathstuf
Branches: f20 f19 f18 el6
InitialCC: haskell-sig
Comment 9 Gwyn Ciesla 2013-08-27 08:13:44 EDT
Git done (by process-git-requests).
Comment 10 Fedora Update System 2013-09-03 21:14:51 EDT
ghc-haskell-lexer-1.0-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/ghc-haskell-lexer-1.0-2.fc18
Comment 11 Fedora Update System 2013-09-03 21:15:02 EDT
ghc-haskell-lexer-1.0-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ghc-haskell-lexer-1.0-2.fc19
Comment 12 Fedora Update System 2013-09-04 21:29:14 EDT
ghc-haskell-lexer-1.0-2.fc18 has been pushed to the Fedora 18 testing repository.
Comment 13 Fedora Update System 2013-09-13 22:32:38 EDT
ghc-haskell-lexer-1.0-2.fc19 has been pushed to the Fedora 19 stable repository.
Comment 14 Fedora Update System 2013-09-13 22:35:41 EDT
ghc-haskell-lexer-1.0-2.fc18 has been pushed to the Fedora 18 stable repository.

Note You need to log in before you can comment on or make changes to this bug.